# frozen_string_literal: true

require "#{File.dirname(__FILE__)}/req/unit-test"

# Encoding Setting.
Encoding.default_internal = 'UTF-8'
Encoding.default_external = 'UTF-8'

# AutoRunner UnitTest.
class Allrun
  attr_reader :runner

  def initialize
    @runner = Test::Unit::AutoRunner.run(true, './test')
  end

  def remove
    remove_instance_variable(:@runner)
  end
end

# Filename find loads.
class Filename
  attr_reader :file_name

  def initialize
    @file_name = Dir.glob("#{File.dirname(__FILE__)}/test/*.rb")
  end

  def remove
    remove_instance_variable(:@file_name)
  end
end

# refinement use module
module Load
  refine Allrun do
    def find_test
      runner
    end
  end
end

# refinement use module
module LoadR
  refine Filename do
    def test_run
      file_name
    end
  end
end

# Ouutput test result.
begin
  puts ''
  puts ' TimeStamp '.center(60, '-')
  puts ''
  HimekuriClass.new.himekuri_print
  puts ''
  puts ' TimeStamp '.center(60, '-')
  puts ''
  puts '[ ミニテストファイル読み込み ]'
  puts ''
  using Load
  puts Filename.new.remove
  puts ''
  puts ' ./test in filename list...exit. '.center(60, '-')
  puts ''
  puts ''
  puts ' Test All Start '.center(60, '-')
  puts ''
  using LoadR
  Allrun.new.remove
  puts ''
  puts ' Test All End '.center(60, '-')
  puts ''
rescue LoadError => e
  puts e.backtrace
ensure
  GC.compact
end

__END__
